%
% dq̒RƃC_N^X̓ASY
%						2019/09/18 Yuki YOKOKURA
clc;
clear;

% CSVt@Cݒ
FileName = '../DATA.csv';

% p[^ݒ
Ts       = 250e-6;	% [s] TvO
Tfcs_sta = 5.5;		% [s] vɎgf[^̊Jn
Tfcs_end = 6.9;		% [s] vɎgf[^̏I
Tstep    = 6.0;		% [s] Xebv͊Jn
Tstd_sta = 6.5;	% [s] ԊJn
Tstd_end = 6.9;	% [s] ԏI

% CSVt@Cϐlǂݍ
CsvData  = csvread(FileName);
t   = CsvData(:,1);
Vdq = CsvData(:,2);
Idq = CsvData(:,3);
clear CsvData;
tlen = length(t);

% f[^̕\
figure(1);
clf;
subplot(2,1,1);
	h = plot(t, Vdq);
	set(h,'LineWidth',2);
	xlabel('Time [s]');
	ylabel('Voltage Vd or Vq [V]');
	grid on;
subplot(2,1,2);
	h = plot(t, Idq);
	set(h,'LineWidth',2);
	xlabel('Time [s]');
	ylabel('Current Id or Iq [A]');
	grid on;

% f[^؂oCdľv63.2̌vZ
Iastd = mean(Idq((Tstd_sta/Ts):(Tstd_end/Ts)));
Ia632 = Iastd*(1 - exp(-1));
t = t((Tfcs_sta/Ts):(Tfcs_end/Ts)) - Tstep;
Ia = Idq((Tfcs_sta/Ts):(Tfcs_end/Ts));

% 63.2̏ꏊ̒T
ep = 0.01;	% T̋e
idx = round(mean(find( (Ia632 - ep) < Ia & Ia < (Ia632 + ep) ))); % 63.2炢ɓvfԍ擾
if(isnan(idx) == true)
	warning('eq63.2t߂̃f[^܂Bep傫ĉB');
else
	tau = t(idx);   % 萔擾
end;

% RƃC_N^X̌vZ
Rdq = max(Vdq)/Iastd;
Ldq = Rdq*tau;

% vf[^\
figure(2);
	h = plot(t, Ia, [t(1) t(length(t))], [Iastd Iastd], [t(1) t(length(t))], [Ia632 Ia632], [0 0], [0 Iastd], [tau tau], [0 Iastd]);
	set(h,'LineWidth',2);
	xlabel('Time [s]');
	ylabel('Current Id or Iq [A]');
    title(strcat('Time constant \tau = ',sprintf(' %e',tau),' [s]  Resistance Rd or Rq = ',sprintf(' %e', Rdq),' [Ohm]  Inductance Ld or Lq = ',sprintf(' %e', Ldq),' [H]'));
	grid on;

% EPSt@C
print(gcf,'-depsc2','-tiff','RdqLdqIdentResults.eps');

% lł̃V~[V
s = tf('s');
P = 1/(Ldq*s + Rdq);
Iasim = lsim(P, Vdq((Tfcs_sta/Ts):(Tfcs_end/Ts)), [0:Ts:((Tfcs_end/Ts) - (Tfcs_sta/Ts))*Ts]);
figure(3);
	h = plot(t, Ia,'k', t, Iasim,'r');
	set(h,'LineWidth',2);
	xlabel('Time [s]');
	ylabel('Current Id or Iq [A]');
	legend('Measured','Identified');
	grid on;

